import { AppConfiguration } from './AppConfiguration';
import { Registration } from '@ts-ioc/core';
/**
 * Inject ApplicationToken
 *
 * @export
 * @class InjectApplicationToken
 * @extends {Registration<T>}
 * @template T
 */
export declare class InjectApplicationToken<T extends IApplication> extends Registration<T> {
    constructor(desc: string);
    static classAnnations: any;
}
/**
 * Application Token.
 */
export declare const ApplicationToken: InjectApplicationToken<IApplication>;
/**
 * application.
 *
 * @export
 * @interface IApplication
 */
export interface IApplication {
    /**
     * application configuration.
     *
     * @type {AppConfiguration<any>}
     * @memberof IApplication
     */
    config?: AppConfiguration<any>;
}
