"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var IModuleBuilder_1 = require("../IModuleBuilder");
var IApplication_1 = require("../IApplication");
var DIModule_1 = require("./DIModule");
/**
 * create bootstrap decorator.
 *
 * @export
 * @template T
 * @param {string} decorType
 * @param {(Token<IModuleBuilder<T>> | IModuleBuilder<T>)} builder
 * @param {InjectToken<IApplication>} provideType default provide type.
 * @param {MetadataAdapter} [adapter]
 * @param {MetadataExtends<T>} [metadataExtends]
 * @returns {IBootstrapDecorator<T>}
 */
function createBootstrapDecorator(decorType, builder, provideType, adapter, metadataExtends) {
    return DIModule_1.createDIModuleDecorator(decorType, builder, provideType, adapter, metadataExtends);
}
exports.createBootstrapDecorator = createBootstrapDecorator;
/**
 * Bootstrap Decorator, definde class as mvc bootstrap module.
 *
 * @Bootstrap
 */
exports.Bootstrap = createBootstrapDecorator('bootstrap', IModuleBuilder_1.ModuleBuilderToken, IApplication_1.ApplicationToken);

//# sourceMappingURL=../sourcemaps/decorators/Bootstrap.js.map
